#include <conio.h>
#include <stdio.h>
#include <string.h>

// definicja typu OSOBA
const int DL=10;
struct OSOBA
 {int Wzrost;
  char Nazwisko[DL];
 };

//deklaracje uniwersalnych funkcji we/wy dla struktur typu OSOBA
void Pokaz_dane (OSOBA &Dana);
OSOBA Dane();
// deklaracje pomocniczych funkcji obsugujcych menu programu oraz komunikaty
 const int POZ=9;
 char Menu(const int ile, char *Polecenia[POZ]);
// deklaracje funkcji dla zdefiniowanej dynamicznej tablicy
//wskaznikow na dynamiczne struktury jako listy nieuporzdkowanej
 
 int Wstaw(OSOBA**tab, OSOBA dane, int ktory, int &ile, int N);
 int Usun(OSOBA**tab, int ktory, int &ile);
 int Wyswietl(OSOBA**tab, int ile);
 void Usunpamiec(OSOBA**&tab, int&ile,int& N);
 OSOBA** new_(OSOBA**tab, int ile, int& N);
 
 int PrzygotujTablice(OSOBA**&tab, int &ile, int& N);
 int Zapisdopliku(OSOBA**tab, int ile);
 int Odczytzpliku(OSOBA**tab, int& ile, int N);

//przykadowa aplikacja wykorzystujca list nieuporzdkowan reprezentowan przez
// dynamiczn tablic wskaznikow na dynamiczne struktury

char *Polecenia[POZ]={"Tablica OSOBA** - obsluga typu lista",
 " Nacisnij:",
 " 1 - aby wstawic element do listy osob",
 " 2 - aby usunac element z listy osob",
 " 3 - aby wyswietlic liste osob, ",
 " 4 - aby usunac liste osob",
 " 5 - aby zapisac do pliku o formacie binarnym",
 " 6 - aby odczytac z pliku o formacie binarnym",
 " Esc - aby zakonczyc prace."};

char *Stan[]=
  {"Tablica pelna",
 " Wstawiono poprawnie",
 " Zly numer do wstawienia",
 " Tablica pusta",
 " Usunieto poprawie",
 " Zly numer do usuwania",
 " Wyswietlono poprawnie",
 " Nie otwarto pliku do zapisu",
 " Dokonano zapisu do pliku",
 " Nie otwarto pliku do czytania",
 " Odczytano plik",
 " Nie odczytano pliku",
 " Brak danych w pliku",
 " Brak pamieci",
 " Zwiekszono pamiec"};


 // funkcja oglnego przeznaczenia
 int Integer(char*);

void main(void)
{int ile=0,N=0, ktory,stan;
 OSOBA**tab=NULL;
 char Co;
  do
  {Co = Menu(POZ,Polecenia);
   switch(Co)
    {case '1' : OSOBA pom=Dane();
								ktory=Integer("\nPodaj indeks w tablicy: ");
                if (ile==N) tab=new_(tab, ile, N);
                if (ile==N) printf("%s\n",Stan[13]);                       
                else printf("%s\n",Stan[Wstaw(tab,pom,ktory,ile,N)]); break;
     case '2' : ktory=Integer("\nPodaj indeks: ");
                printf("\n%s\n",Stan[Usun(tab,ktory,ile)]); break;
		 case '3' : printf("\n%s\n",Stan[Wyswietl(tab,ile)]); break;
     case '4' : Usunpamiec(tab, ile, N); break;

     case '5' : printf("\n%s\n",Stan[Zapisdopliku(tab,ile)]); break;
     case '6' : stan=PrzygotujTablice(tab,ile,N);
                printf("\n%s\n",Stan[stan]);
                if (stan == 14)   
                  printf("\n%s\n",Stan[Odczytzpliku(tab,ile,N)]); break;
     case 27  : printf("%s\n","\nKoniec programu"); break;
     default  : printf("%s\n","\nZla opcja");
   }
   getch();
	 }while (Co !=27);
   Usunpamiec(tab,ile,N);
  }

int Integer(char* s)
 { int ktory;
   printf("\n\n%s",s);
   scanf("%d",&ktory);
   return ktory; }

//definicje uniwersalnych funkcji we/wy dla struktur typu OSOBA
 OSOBA Dane()
 {char bufor[DL+2];
  OSOBA Nowy;
  bufor[0]=DL;
  Nowy.Wzrost=Integer("\nwzrost: ");
  printf("\nnazwisko: ");
  strcpy(Nowy.Nazwisko,cgets(bufor));
  return Nowy;
  }

 void Pokaz_dane(OSOBA &Dana)
 { printf("\n\nWzrost: %d\n", Dana.Wzrost);
   printf("Nazwisko:        %s\n", Dana.Nazwisko);
   printf("Nacisnij dowolny klawisz...\n");
   getch();
  }

// definicje pomocniczych funkcji obsugujcych menu programu oraz komunikaty
 char Menu(const int ile, char *Polecenia[])
  {clrscr();
   for (int i=0; i<ile;i++)
      printf("\n%s",Polecenia[i]);
   return getch();}

   
//definicje funkcji oslugujacych dynamiczne tablice wskaznikow na dymamiczne struktury
int Wstaw(OSOBA** tab, OSOBA dane, int ktory,int &ile, int N)
 {if (ile==N) return 0;
  if( ktory<0 || ktory>ile) return 2;
  OSOBA* pom= new OSOBA;   //przydzia pamieci na nowa osob
  if (pom==NULL) return 13;
  *pom=dane;    //skopiowanie danych o osobie do prydzielonej pamieci
  for (int i=ile; i>ktory; i--) // zaoenia: 0<=ile<N i 0<=ktory<=ile
   tab[i]=tab[i-1];
  tab[ktory]=pom;     //wstawienie danej czyli adresu nowej osoby
  ile++;
  return 1;
 }

OSOBA** new_(OSOBA** tab, int ile, int &N)
 {
  OSOBA** pom= new OSOBA* [N+5];
  if (pom!=NULL)
   {N+=5;
    for(int i=0;i<ile;i++)
       {pom[i]=tab[i]; }//memmove(pom,tab,ile*sizeof(OSOBA*));
    delete[] tab;
    tab=pom;
    }
   return tab;
 }

int Usun(OSOBA** tab, int ktory, int &ile)
 { if (ile==0) return 3;
   if (ktory<0 || ktory>=ile) return 5;
   delete tab[ktory];    //usuniecie pamieci przeznaczonej na osobe
   for (int i=ktory; i<ile-1; i++)  // zaoenia: 0<ile<=N i 0<=ktory<=ile-1
      tab[i]=tab[i+1];
   ile--;
   return 4;
 }

void Usunpamiec(OSOBA**&tab, int&ile, int& N)
{ for(int i=0;i<ile;i++)
    delete tab[i];
  delete[] tab;  
  tab=NULL;
  ile=0;
  N=0;
 }

int Wyswietl(OSOBA** tab, int ile)
 { if(ile==0) return 3;
   for (int i=0; i<ile;i++)
     Pokaz_dane(*tab[i]);   //wykonaj czynno na elementach tablicy
    return 6;
  }



int Zapisdopliku(OSOBA**tab, int ile)
 {

  FILE *fptr;                      // wskaznik ptr do strumienia FILE
  if( (fptr=fopen("fwrite.bin","wb"))==NULL )  // otwarcie pliku do
       //zapisu w trybie tekstowym
      return 7;
  for (int i=0;i<ile;i++)
    fwrite(tab[i],sizeof(OSOBA),1,fptr); //zapis danych, ktorych adresy sa przechowywane w tablicy
  fclose(fptr);                     // zamkniecie strumienia
  return 8;
 }

int PrzygotujTablice(OSOBA**&tab, int& ile, int& N)
{  FILE *fptr;
 long n=0;
 if( (fptr=fopen("fwrite.bin","rb"))==NULL ) return 9;
 fseek(fptr,0L,SEEK_END);  //ustawienie indeksu na koncu pliku
 n=ftell(fptr)/sizeof(OSOBA); //pobranie pozycji w bajtach ftell i wyznaczenie liczby elementow typu OSOBA
 fclose(fptr);
 if (n==-1L) return 11;
 if (n==0) return 12;
 OSOBA** pom=new OSOBA*[n];
 if (pom==NULL)  return 13;
 Usunpamiec(tab,ile,N);
 tab=pom;
 N = n;
 return 14;
}


int Odczytzpliku(OSOBA**tab, int& ile, int N)
{   
  FILE *fptr;
  OSOBA pom;
  if( (fptr=fopen("fwrite.bin","rb"))==NULL )
  return 9;
  while(fread(&pom, sizeof(OSOBA),1,fptr)==1)
        if(Wstaw(tab,pom,ile,ile,N)==11)
          { fclose(fptr);
            return 11;}
  fclose(fptr);                       // zamkniecie strumienia
  return 10;
 }



